#!/usr/bin/perl -w

# Linux Application Checker
# Browse for File/Directory/Package Module (choose_components.pl)
#
# Copyright (C) 2007-2008 The Linux Foundation. All rights reserved.
#
# This program has been developed by ISP RAS for LF.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# version 2 as published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

use Templates;
use Fcntl ':mode';

print "HTTP/1.0 200 OK\n";
print "Content-type: text/html\n\n";

if (!$_GET{'_frame'}) {
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
# Top-level frameset definition                                               #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

	my $root = (defined($_GET{'root'}) ? $_GET{'root'} : '/');
	my $hidden = (defined($_GET{'hidden'}) ? $_GET{'hidden'} : '1');
	$root = escape($root);
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>Application Components Selection</title>
</head>

<frameset rows="*, 60" onload="javascript:bottom_frame.get_comp_list();">
  <frame src="choose_components.pl?_frame=top&amp;root=$root&amp;hidden=$hidden" name="top_frame" id="top_frame" />
  <frame src="choose_components.pl?_frame=bottom" name="bottom_frame" id="bottom_frame" scrolling="no" />
  <noframes>
    <body><h1 style="color: red;">Your browser does not support frames!</h1></body>
  </noframes>
</frameset>
</html>
DATA
}
elsif ($_GET{'_frame'} eq 'bottom') {
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
# Bottom frame                                                                #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title></title>
  <style type="text/css">
	a {
		color: blue;
	}
  </style>
</head>

<body>
<table cellpadding="0" cellspacing="0" border="0" width="100%">
  <tr>
    <td align="right">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td height="40" style="width: 10em; text-align: left;"><a href="" onclick="javascript:parent.top_frame.show_tab('all-items'); return false;">Selected entries: <span id="num_elems">&hellip;</span></a></td>
          <td><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
          <td><input type="button" value="Finish" style="border: 1px solid black; background: white; width: 8em; font-weight: bold;" onclick="javascript:put_comp_list();" /></td>
          <td><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>
        </tr>
      </table>
    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
// Full list of packages on the system. We store it here to avoid getting it
// again and again on changing directories (which reloads the top frame).
var host_packages = new Array();
var host_packages_empty = true;

// Here we store all the entries the user marked.
var paths_list = new Array();
var num_paths_list = 0;
var pkgs_list = new Array();
var num_pkgs_list = 0;
var comp_list_complete = false;

// Prints the total number of selected paths/packages in the special field.
function update_num_elems() {
	var elem = document.getElementById('num_elems');
	if (elem)
		elem.innerHTML = num_paths_list + num_pkgs_list;
}

// Saves the list of currently entered components into local variables.
function get_comp_list() {
	if (parent.opener) {
		var elem_parent = parent.opener.document.getElementById('components');
		if (elem_parent && elem_parent.value) {
			var arr = elem_parent.value.split('\\n');
			for (var i in arr) {
				var path = arr[i].replace(/^\\s*(.*?)\\s*\$/g, '\$1');
				if ((path != '')) {
					if (path.substr(0, 4) == 'pkg:') {
						path = path.substr(4);
						if (!pkgs_list[path]) {
							pkgs_list[path] = true;
							++num_pkgs_list;
						}
					}
					else {
						if (path[0] != '/') {
							path = '/' + path;
						}
						if (!paths_list[path]) {
							paths_list[path] = true;
							++num_paths_list;
						}
					}
				}
			}
		}
		update_num_elems();
		comp_list_complete = true;
		parent.top_frame.check_path_items();
	}
}

// Writes the list of selected files and directories back into the main window
// and closes the dialog.
function put_comp_list() {
	if (parent.opener) {
		var first_elem = '';    // Can be used for filling in the Application Name field
		var elem = parent.opener.document.getElementById('components');
		if (elem) {
			var to_add = '';
			for (var path in paths_list) {
				if (paths_list[path]) {
					to_add += path + '\\n';
					if (first_elem == '') {
						first_elem = path.substr(path.lastIndexOf('/') + 1);
					}
				}
			}
			for (var pkg in pkgs_list) {
				if (pkgs_list[pkg]) {
					to_add += 'pkg:' + pkg + '\\n';
					if (first_elem == '') {
						first_elem = pkg;
					}
				}
			}
			elem.value = to_add;
		}
		var app_name = parent.opener.document.getElementById('application');
		if ((app_name && (app_name.value == '')) &&
			((num_paths_list == 1) || ((num_paths_list == 0) && (num_pkgs_list == 1)))) {
			app_name.value = first_elem;
			app_name.style.borderColor = parent.opener.input_border_color;
		}
	}
	parent.window.close();
}
// ]]>
</script>

</body>
</html>
DATA
}
elsif ($_GET{'_frame'} eq 'top') {
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
# Top frame                                                                   #
# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

my $cut_path = $_GET{'root'};
$cut_path = "/$cut_path" if ($cut_path !~ m!^/!);

# Obtain the real path that is closest to the requested one
while (($cut_path ne '') and (!-d $cut_path)) {
	$cut_path =~ s!/[^/]*$!!;
}

if ($cut_path eq '/') {
	$cut_path = '';
}

# Current path
my $path = (($cut_path eq '') ? '/' : $cut_path);

# Whether to show hidden files
my $show_hidden = (defined($_GET{'hidden'}) ? ($_GET{'hidden'} ? '1' : '0') : '1');

# Constructs a single tab header
sub header_tab($$$) {
	my ($tab_id, $tab_name, $active) = @_;
	$active = ($active ? 'active' : 'inactive');
	return <<DATA;
    <td align="center" class="tab-$active" id="$tab_id-tab" style="width: 13em;" onclick="javascript:show_tab('$tab_id');"><img src="images/environment-spacer.gif" width="10" height="1" alt="" /><b>$tab_name</b><img src="images/environment-spacer.gif" width="10" height="1" alt="" /><br /><img src="images/environment-spacer.gif" style="width: 13em;" height="1" alt="" /></td>

DATA
}

my $tab_delimiter = '<td style="width: 10px; border-bottom: solid 1px #166a98;"><img src="images/environment-spacer.gif" width="10" height="1" alt="" /></td>';

print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title></title>
  <script type="text/javascript" src="css/app-checker.js"></script>
  <style type="text/css">
	table.main {
		border: 0px solid black;
		border-collapse: collapse;
	}
	table.main td, table.main th {
		border: 1px solid black;
		padding: 4px;
		white-space: nowrap;
	}
	table.main td {
		font-family: monospace;
		font-size: 10pt;
	}
	table.main td.selected {
		color: red;
	}
	a {
		color: blue;
	}
	tr.list_item0 {
		background: #e7e7e7;
	}
	tr.list_item1 {
		background: #ffffff;
	}
	tr.clickable:hover {
		background-color: #d0d0ff;
		cursor: pointer;
	}
	td h3 {
		margin-top: 10px;
		margin-bottom: 0px;
	}
    .tab-active {
        border: solid 1px #166a98;
        border-bottom: none;
        background-color: #a0d5f1;
        color: #004060;
        font-size: smaller;
    }
    .tab-inactive {
        cursor: pointer;
        border: solid 1px #166a98;
        font-size: smaller;
    }
    .tab-inactive:hover {
        background-color: #d9eefd;
        color: #004060;
    }
  </style>
</head>

<body onload="javascript:check_path_items(); ajaxInit();">

<div id="ajax_loading" style="display: none; position: fixed; width: 13em; height: 5.8em; top: 40%; left: 50%; margin-top: -2.9em; margin-left: -7.5em; border: solid 1px #00007f; background-color: #e7f0ff; text-align: center; padding: 6px;"><div align="center">
Please, wait&hellip;<br />
<img src="images/environment-spacer.gif" width="1" height="5" alt="" /><br />
<img src="images/ajax_progress.gif" width="16" height="16" alt="" /><br />
<img src="images/environment-spacer.gif" width="1" height="7" alt="" /><br />
<input type="button" name="ajax_abort" id="ajax_abort" value="Abort" style="border: solid 1px #00007f; background: #e0e0ff; color: blue; width: 6em;" onclick="javascript:onAbort();" />
</div></div>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td align="left" width="100%"><h3>Select Application Components:</h3></td>
    <td><img src="images/environment-spacer.gif" width="10" height="1" border="0" alt="" /></td>
    <td align="right"><h3><a href="tests_help.pl#browse_component" target="_blank">Help</a></h3></td>
  </tr>
</table>

<table cellpadding="0" cellspacing="0" border="0" width="100%" style="white-space: nowrap; padding-top: 0.7em;">
  <tr>
    <td style="width: 20px; border-bottom: solid 1px #166a98; height: 1.2em;"><img src="images/environment-spacer.gif" width="20" height="1" alt="" /></td>
DATA

print header_tab('cur-dir', 'Files&nbsp;and&nbsp;Directories', 1);
print "    $tab_delimiter\n";
print header_tab('packages', 'Installed&nbsp;Packages', 0);
print "    $tab_delimiter\n";
print header_tab('all-items', 'All&nbsp;Selected', 0);

print <<DATA;
    <td style="border-bottom: solid 1px #166a98; width: 100%;"><img src="images/environment-spacer.gif" width="1" height="1" alt="" /></td>
  </tr>
  <tr>
    <td colspan="7" style="background-color: #a0d5f1; height: 3px; border-left: solid 1px #166a98; border-right: solid 1px #166a98;"><img src="images/environment-spacer.gif" width="1" height="1" alt="" /></td>
  </tr>
  <tr>
    <td colspan="7" style="border: solid 1px #166a98; border-top: none; padding: 10px;">

<div id="cur-dir">
<table border="0" cellpadding="0" cellspacing="0" width="100%" style="margin-bottom: 10px;">
  <tr>
    <td align="left" width="100%">
DATA

my @path_dirs = split(/\//, $path);
my $cur_path = '';
my $cur_path_esc = '';
print "<a href=\"choose_components.pl?_frame=top&amp;root=%2F&amp;hidden=$show_hidden\"><b>root</b></a>";
foreach $dir (@path_dirs) {
	next if (!$dir);
	$cur_path .= "/$dir";
	$cur_path_esc = escape($cur_path);
	print " / <a href=\"choose_components.pl?_frame=top&amp;root=$cur_path_esc&amp;hidden=$show_hidden\">$dir</a>";
}
my $inv_show_hidden = ($show_hidden ? '0' : '1');
my $checked = ($show_hidden ? ' checked="checked"' : '');
print <<DATA;
</td>
  </tr>
  <tr>
    <td style="height: 0.5em;"><img src="images/environment-spacer.gif" width="1" height="1" border="0" alt="" /></td>
  </tr>
  <tr>
    <td><label><input type="checkbox" id="show_hidden"$checked onclick="javascript:document.location='choose_components.pl?_frame=top&amp;root=$cur_path_esc&amp;hidden=$inv_show_hidden';" />&nbsp;Show&nbsp;hidden</label></td>
  </tr>
</table>

DATA

if (!opendir(CUR_DIR, $path)) {
	print "<b><font color=\"red\">Error: Could not open directory!</font><br />$!</b>\n";
}
else {
	my @listing;
	if ($show_hidden) {
		@listing = grep(!/^\.+$/, readdir(CUR_DIR));
	}
	else {
		@listing = grep(!/^\./, readdir(CUR_DIR));
	}
	closedir(CUR_DIR);

	print <<DATA;
<div id="wrong_paths" style="display: none;">
<font color="red"><b>WARNING:</b></font> The following entries from this directory are selected but do not exist:<br />
<div id="wrong_paths_data">
</div>
<br />
</div>

<table class="main">
  <tr>
    <th style="width: 1.2em;"></th>
    <th colspan="2">Name</th>
    <th>Size</th>
    <th>Date/Time</th>
    <th>Owner</th>
    <th>Attr</th>
  </tr>
DATA

	my %file_info = ();
	my %dir_info = ();

	foreach my $name (@listing) {
		my @lstat_data = lstat("$cut_path/$name");
		if (scalar(@lstat_data) > 0) {
			my ($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size, $atime, $mtime, $ctime, $blksize, $blocks) = @lstat_data ;
			my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($mtime);
			my $date_time = sprintf('%04d-%02d-%02d %02d:%02d', ($year + 1900), ($mon + 1), $mday, $hour, $min);
			my $owner = (getpwuid($uid) or $uid);
			my $group = (getgrgid($gid) or $gid);
			my $lnk_target = readlink("$cut_path/$name");
			my $isdir = (-d "$cut_path/$name");

			my $fmt_mode = '';
			if (($mode & S_IFSOCK) == S_IFSOCK) {
				# Socket
				$fmt_mode = 's';
			}
			elsif (($mode & S_IFLNK) == S_IFLNK) {
				# Symbolic link
				$fmt_mode = 'l';
			}
			elsif (($mode & S_IFREG) == S_IFREG) {
				# Regular file
				$fmt_mode = '-';
			}
			elsif (($mode & S_IFBLK) == S_IFBLK) {
				# Block device
				$fmt_mode = 'b';
			}
			elsif (($mode & S_IFDIR) == S_IFDIR) {
				# Directory
				$fmt_mode = 'd';
			}
			elsif (($mode & S_IFCHR) == S_IFCHR) {
				# Character device
				$fmt_mode = 'c';
			}
			elsif (($mode & S_IFIFO) == S_IFIFO) {
				# FIFO
				$fmt_mode = 'p';
			}
			else {
				$fmt_mode = '-';
			}
			$fmt_mode .= (($mode & S_IRUSR) ? 'r' : '-');
			$fmt_mode .= (($mode & S_IWUSR) ? 'w' : '-');
			$fmt_mode .= (($mode & S_ISUID) ? (($mode & S_IXUSR) ? 's' : 'S') : (($mode & S_IXUSR) ? 'x' : '-'));
			$fmt_mode .= (($mode & S_IRGRP) ? 'r' : '-');
			$fmt_mode .= (($mode & S_IWGRP) ? 'w' : '-');
			$fmt_mode .= (($mode & S_ISGID) ? (($mode & S_IXGRP) ? 's' : 'S') : (($mode & S_IXGRP) ? 'x' : '-'));
			$fmt_mode .= (($mode & S_IROTH) ? 'r' : '-');
			$fmt_mode .= (($mode & S_IWOTH) ? 'w' : '-');
			$fmt_mode .= (($mode & S_ISVTX) ? (($mode & S_IXOTH) ? 't' : 'T') : (($mode & S_IXOTH) ? 'x' : '-'));

			if ($isdir) {
				$dir_info{$name}{'SIZE'} = $size;
				$dir_info{$name}{'DATE_TIME'} = "$date_time";
				$dir_info{$name}{'OWNER'} = "$owner:$group";
				$dir_info{$name}{'ATTR'} = $fmt_mode;
				$dir_info{$name}{'LINK'} = ($lnk_target ? " title=\"Symbolic link to $lnk_target\"" : '');
			}
			else {
				$file_info{$name}{'SIZE'} = $size;
				$file_info{$name}{'DATE_TIME'} = "$date_time";
				$file_info{$name}{'OWNER'} = "$owner:$group";
				$file_info{$name}{'ATTR'} = $fmt_mode;
				$file_info{$name}{'VALID_LINK'} = (scalar(stat("$cut_path/$name")) != 0);
				$file_info{$name}{'LINK'} = ($lnk_target ? " title=\"Symbolic link to $lnk_target".($file_info{$name}{'VALID_LINK'} ? '' : ' (BROKEN!)')."\"" : '');
			}
		}
		else {
			# File could have been deleted at this moment, ignore it.
			# But other errors we'll display.
			if (!$!{'ENOENT'}) {
				$file_info{$name}{'ERROR'} = $!;
			}
		}
	}

	my $odd_line = 0;
	my $name_to_id = '';

	foreach $name (sort keys %dir_info) {
		my $tmp_path = escape("$cut_path/$name");
		my $name_id = $name;
		$name_id =~ s/([^a-zA-Z0-9\-_:])/sprintf('.%02X', ord($1))/eg;
		my $name_disp = $name;
		$name_disp =~ s/&/&amp;/g;
		my $img = ($dir_info{$name}{'LINK'} ? 'sel_ldir.png' : 'sel_dir.png');
		print <<DATA;
  <tr class="list_item$odd_line clickable" onclick="javascript:document.location='choose_components.pl?_frame=top&amp;root=$tmp_path&amp;hidden=$show_hidden';">
    <td onclick="javascript:selectPathItem('$name_id', '$name', true);event.cancelBubble = true;"><input type="checkbox" name="path-chk-$name_id" id="path-chk-$name_id" onclick="javascript:selectPathItem('$name_id', '$name', false);event.cancelBubble = true;" /></td>
    <td style="text-align: center; vertical-align: middle; border-right: none;"$dir_info{$name}{'LINK'}><img src="images/$img" width="14" height="12" alt="D" /></td>
    <td id="path-item-$name_id" style="width: 20em; vertical-align: middle; border-left: none;"$dir_info{$name}{'LINK'}><b>$name_disp</b></td>
    <td align="right" style="width: 4em;">$dir_info{$name}{'SIZE'}</td>
    <td>$dir_info{$name}{'DATE_TIME'}</td>
    <td>$dir_info{$name}{'OWNER'}</td>
    <td>$dir_info{$name}{'ATTR'}</td>
  </tr>
DATA
		$odd_line = 1 - $odd_line;
		$name_to_id .= "\tname_to_id['$name'] = '$name_id';\n";
	}

	foreach $name (sort keys %file_info) {
		my $name_id = $name;
		$name_id =~ s/([^a-zA-Z0-9\-_:])/sprintf('.%02X', ord($1))/eg;
		my $name_disp = $name;
		$name_disp =~ s/&/&amp;/g;
		if (!$file_info{$name}{'ERROR'}) {
			my $img = ($file_info{$name}{'LINK'} ? ($file_info{$name}{'VALID_LINK'} ? 'sel_lfile.png' : 'sel_lbad.png') : 'sel_file.png');
			print <<DATA;
  <tr class="list_item$odd_line clickable" onclick="javascript:selectPathItem('$name_id', '$name', true);">
    <td><input type="checkbox" name="path-chk-$name_id" id="path-chk-$name_id" onclick="javascript:selectPathItem('$name_id', '$name', false);event.cancelBubble = true;" /></td>
    <td style="text-align: center; vertical-align: middle; border-right: none;"$file_info{$name}{'LINK'}><img src="images/$img" width="11" height="14" alt="F" /></td>
    <td id="path-item-$name_id" style="width: 20em; vertical-align: middle; border-left: none;"$file_info{$name}{'LINK'}><b>$name_disp</b></td>
    <td align="right" style="width: 4em;">$file_info{$name}{'SIZE'}</td>
    <td>$file_info{$name}{'DATE_TIME'}</td>
    <td>$file_info{$name}{'OWNER'}</td>
    <td>$file_info{$name}{'ATTR'}</td>
  </tr>
DATA
		}
		else {
			print <<DATA;
  <tr class="list_item$odd_line">
    <td><input type="checkbox" name="path-chk-$name_id" id="path-chk-$name_id" disabled="disabled" /></td>
    <td style="text-align: center; vertical-align: middle; border-right: none;"><img src="images/sel_lbad.png" width="11" height="14" alt="B" /></td>
    <td id="path-item-$name_id" style="width: 20em; vertical-align: middle; border-left: none;"><b>$name_disp</b></td>
    <td colspan="4" align="center"><b><font color="red">&lt;$file_info{$name}{'ERROR'}&gt;</font></b></td>
  </tr>
DATA
		}
		$odd_line = 1 - $odd_line;
		$name_to_id .= "\tname_to_id['$name'] = '$name_id';\n";
	}

	my $delim = ($is_packager_rpm ? '-' : '_');
	print <<DATA;
</table>
</div>

<div id="packages"></div>

<div id="all-items" style="display: none;">
</div>

    </td>
  </tr>
</table>

<script language="javascript" type="text/javascript">
// <![CDATA[
////////////////////////////////////////////////////////////////////////////////
// Work with paths selection
////////////////////////////////////////////////////////////////////////////////

// Variable containing currently opened path.
var current_path = '$cut_path';

// Array for getting element id from file name.
// JS regular expressions seem to be too weak for this task...
var name_to_id = new Array();

// Perl-generated function to fill name_to_id values.
function fill_name_to_id() {
$name_to_id
}

// Array for storing names of the missing files.
var wrong_paths = new Array();

// Synchronization variable
var check_path_items_performed = false;

// Checks the elements checkboxes according to the previous selection
function check_path_items() {
	// Protect ourselves from JS errors in case the function is called prior to
	// loading the bottom frame. It will be called again from there, so for now
	// simply exit.
	if (!parent.bottom_frame.comp_list_complete)
		return;

	// Protect from double-execution, if the first call did succeed.
	if (check_path_items_performed)
		return;

	check_path_items_performed = true;

	if (parent.opener) {
		var elem_hidden = parent.opener.document.getElementById('show_hidden_files');
		if (elem_hidden)
			elem_hidden.value = '$show_hidden';
		var elem_last_dir = parent.opener.document.getElementById('last_opened_dir');
		if (elem_last_dir)
			elem_last_dir.value = '$path';
	}

	// First, fill in the name_to_id array.
	fill_name_to_id();
	wrong_paths = new Array();

	// Then set the checkmarks.
	for (var path in parent.bottom_frame.paths_list) {
		if (parent.bottom_frame.paths_list[path]) {
			var pos = path.lastIndexOf('/');
			var file_name = path.substr(pos + 1);
			var dir = path.substr(0, pos);
			if (dir == current_path) {
				var file_name_id = name_to_id[file_name];
				if (!file_name_id)
					wrong_paths.push(file_name);
				else {
					var elem = document.getElementById('path-chk-' + file_name_id);
					if (elem)
						elem.checked = true;
					elem = document.getElementById('path-item-' + file_name_id);
					if (elem)
						elem.className = 'selected';
				}
			}
		}
	}

	// Process missing files if any.
	var wpath_div = document.getElementById('wrong_paths');
	var wpath_data = document.getElementById('wrong_paths_data');
	if (wpath_div && wpath_data) {
		if (wrong_paths.length != 0) {
			var str = '<table class="main">\\n';
			for (var i in wrong_paths) {
				str += '  <tr class="clickable" onclick="javascript:selectWPathItem(' + i + ', true);" >\\n    <td style="width: 1.4em;"><input type="checkbox" name="wpath-chk-' + i + '" id="wpath-chk-' + i + '" checked="checked" onclick="javascript:selectWPathItem(' + i + ', false);event.cancelBubble=true;" /></td>\\n    <td id="wpath-item-' + i + '" class="selected" style="width: 20em;"><strike><b>' + wrong_paths[i].replace(/&/g, '&amp;') + '</b></strike></td>\\n  </tr>\\n';
			}
			str += '</table>\\n';
			wpath_data.innerHTML = str;
			wpath_div.style.display = '';
		}
		else {
			wpath_div.style.display = 'none';
		}
	}
}

// Updates internal information when (un)selecting files and dirs.
function selectPathItem(elem_id, file_name, set_checkbox) {
	var checkbox = document.getElementById('path-chk-' + elem_id);
	var item = document.getElementById('path-item-' + elem_id);
	if (!checkbox || !item)
		return;
	if (set_checkbox)
		checkbox.checked = !checkbox.checked;
	var full_path = current_path + '/' + file_name;
	if (checkbox.checked) {
		parent.bottom_frame.paths_list[full_path] = true;
		++parent.bottom_frame.num_paths_list;
		item.className = 'selected';
	}
	else {
		parent.bottom_frame.paths_list[full_path] = false;
		--parent.bottom_frame.num_paths_list;
		item.className = '';
	}
	parent.bottom_frame.update_num_elems();
}

// Updates internal information when (un)selecting missing files and dirs.
function selectWPathItem(elem_num, set_checkbox) {
	var checkbox = document.getElementById('wpath-chk-' + elem_num);
	var item = document.getElementById('wpath-item-' + elem_num);
	if (!checkbox || !item)
		return;
	if (set_checkbox)
		checkbox.checked = !checkbox.checked;
	var full_path = current_path + '/' + wrong_paths[elem_num];
	if (checkbox.checked) {
		parent.bottom_frame.paths_list[full_path] = true;
		++parent.bottom_frame.num_paths_list;
		item.className = 'selected';
	}
	else {
		parent.bottom_frame.paths_list[full_path] = false;
		--parent.bottom_frame.num_paths_list;
		item.className = '';
	}
	parent.bottom_frame.update_num_elems();
}

////////////////////////////////////////////////////////////////////////////////
// Work with packages selection
////////////////////////////////////////////////////////////////////////////////

// Function to represent character as hex code.
function charToHex(ch) {
	var val = ch.charCodeAt(0);
	var val_hi = Math.floor(val / 16);
	var val_lo = val - val_hi * 16;
	return val_hi.toString(16).toUpperCase() + val_lo.toString(16).toUpperCase();
}

function hexToChar(str) {
	var res = 0;
	if ((str[0] >= '0') && (str[0] <= '9'))
		res = str.charCodeAt(0) - 48;
	else
		res = str.charCodeAt(0) - 55;
	res *= 16;
	if ((str[1] >= '0') && (str[1] <= '9'))
		res += str.charCodeAt(1) - 48;
	else
		res += str.charCodeAt(1) - 55;
	return res;
}

// Function to escape string so that it met W3C restrictions on ID HTML attribute.
// Algorithm is the same as used in AJAX server for generating list of packages.
function escapeID(str) {
	var res = '';
	for (var i=0; i<str.length; ++i) {
		if (str[i].search(/[^a-zA-Z0-9\\-_]/) == -1)
			res += str[i];
		else
			res += '.' + charToHex(str[i]);
	}
	return res;
}

// Function to unescape the escaped ID string and convert it into normal package name.
function unescapeID(str) {
	var tmp = str.replace(/::/g, '$delim');
	var res = '';
	for (var i=0; i<tmp.length; ++i) {
		if (tmp[i] == '.') {
			res += String.fromCharCode(hexToChar(tmp[i + 1] + tmp[i + 2]));
			i += 2;
		}
		else
			res += tmp[i];
	}
	return res;
}

// Array for storing names of the missing packages.
var wrong_pkgs = new Array();

// Checks the elements checkboxes according to the previous selection.
function check_pkg_items() {
	var new_pkgs_id = new Array();
	wrong_pkgs = new Array();
	var i;

	// Then set the checkmarks.
	for (var pkg in parent.bottom_frame.pkgs_list) {
		if (parent.bottom_frame.pkgs_list[pkg]) {
DATA

	if ($is_packager_rpm) {
		print <<DATA;
			// 3 possible variants of input package name:
			//   a) name-version-release
			//   b) name-version
			//   c) name
			// We try to check every one of them (cannot tell for sure:
			// names may contain a hyphen which is a delimiter).
			var pkg_nam1, pkg_ver1, pkg_rel1;       // 'name-version-release' => 'name', 'version', 'release'
			var pkg_nam2, pkg_ver2;                 // 'name-version'         => 'name', 'version', '*'
			var pkg_nam3;                           // 'name'                 => 'name', '*',       '*'
			var elems, tmp;
			var found = false;

			var pkg_id = escapeID(pkg);
			var pos = pkg_id.lastIndexOf('$delim');
			pkg_rel1 = pkg_id.substr(pos + 1);
			tmp = pkg_id.substr(0, pos);
			pos = tmp.lastIndexOf('$delim');
			pkg_ver1 = tmp.substr(pos + 1);
			pkg_ver2 = pkg_rel1;
			pkg_nam1 = tmp.substr(0, pos);
			pkg_nam2 = tmp;
			pkg_nam3 = pkg_id;

			// Check first hypotesis ('name-version-release').
			elems = document.getElementsByName('pkg-chk-' + pkg_nam1);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(8);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam1) && (params[1] == pkg_ver1) && (params[2] == pkg_rel1)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// Check second hypotesis ('name-version').
			elems = document.getElementsByName('pkg-chk-' + pkg_nam2);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(8);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam2) && (params[1] == pkg_ver2)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// Check third hypotesis ('name').
			elems = document.getElementsByName('pkg-chk-' + pkg_nam3);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(8);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam3)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// If at least one element was found, reset the source package name.
			// Else mark the package as missing.
			if (found) {
				parent.bottom_frame.pkgs_list[pkg] = false;
				--parent.bottom_frame.num_pkgs_list;
			}
			else
				wrong_pkgs.push(pkg);
DATA
	}
	else {
		print <<DATA;
			// 2 possible variants of input package name:
			//   a) name_version
			//   b) name
			// We try to check every one of them (suppose that name
			// cannot contain an underscore, but version can).
			var pkg_nam1, pkg_ver1;                 // 'name_version' => 'name', 'version'
			var pkg_nam2;                           // 'name'         => 'name', '*'
			var elems, tmp;
			var found = false;

			var pkg_id = escapeID(pkg);
			var pos = pkg_id.indexOf('$delim');
			pkg_nam1 = pkg_id.substr(0, pos);
			pkg_ver1 = pkg_id.substr(pos + 1);
			pkg_nam2 = pkg_id;

			// Check first hypotesis ('name_version').
			elems = document.getElementsByName('pkg-chk-' + pkg_nam1);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(8);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam1) && (params[1] == pkg_ver1)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// Check second hypotesis ('name').
			elems = document.getElementsByName('pkg-chk-' + pkg_nam2);
			for (i=0; i<elems.length; ++i) {
				var id = elems[i].id.substr(8);
				var params = id.split(/::/);
				if ((params[0] == pkg_nam2)) {
					found = true;
					new_pkgs_id.push(id);
				}
			}

			// If at least one element was found, reset the source package name.
			// Else mark the package as missing.
			if (found) {
				parent.bottom_frame.pkgs_list[pkg] = false;
				--parent.bottom_frame.num_pkgs_list;
			}
			else
				wrong_pkgs.push(pkg);
DATA
	}

	print <<DATA;
		}
	}

	// Process all found packages.
	for (i=0; i<new_pkgs_id.length; ++i) {
		var elem_chk = document.getElementById('pkg-chk-' + new_pkgs_id[i]);
		var elem_item = document.getElementById('pkg-item-' + new_pkgs_id[i]);
		if (elem_chk && elem_item) {
			elem_chk.checked = true;
			elem_item.className = 'selected';
			parent.bottom_frame.pkgs_list[unescapeID(new_pkgs_id[i])] = true;
			++parent.bottom_frame.num_pkgs_list;
		}
		else {
			alert('Internal error while trying to mark package ' + new_pkgs_id[i] + '.\\nPlease, report to linux\@ispras.ru.');
		}
	}

	// Process missing packages if any.
	if (wrong_pkgs.length != 0) {
		var wpkg_div = document.getElementById('wrong_pkgs');
		var wpkg_data = document.getElementById('wrong_pkgs_data');
		if (wpkg_div && wpkg_data) {
			var str = '<table class="main">\\n';
			for (var i in wrong_pkgs) {
				str += '  <tr class="clickable" onclick="javascript:selectWPkgItem(' + i + ', true);">\\n    <td style="width: 1.4em;"><input type="checkbox" name="wpkg-chk-' + i + '" id="wpkg-chk-' + i + '" checked="checked" onclick="javascript:selectWPkgItem(' + i + ', false);event.cancelBubble=true;" /></td>\\n    <td id="wpkg-item-' + i + '" class="selected" style="width: 20em;"><strike><b>' + wrong_pkgs[i].replace(/&/g, '&amp;') + '</b></strike></td>\\n  </tr>\\n';
			}
			str += '</table>\\n';
			wpkg_data.innerHTML = str;
			wpkg_div.style.display = '';
		}
	}

	parent.bottom_frame.update_num_elems();
}

// Updates internal information when (un)selecting packages.
function selectPkgItem(elem_id, pkg_name, set_checkbox) {
	var checkbox = document.getElementById('pkg-chk-' + elem_id);
	var item = document.getElementById('pkg-item-' + elem_id);
	if (!checkbox || !item)
		return;
	if (set_checkbox)
		checkbox.checked = !checkbox.checked;
	if (checkbox.checked) {
		parent.bottom_frame.pkgs_list[pkg_name] = true;
		++parent.bottom_frame.num_pkgs_list;
		item.className = 'selected';
	}
	else {
		parent.bottom_frame.pkgs_list[pkg_name] = false;
		--parent.bottom_frame.num_pkgs_list;
		item.className = '';
	}
	parent.bottom_frame.update_num_elems();
}

// Updates internal information when (un)selecting missing packages.
function selectWPkgItem(elem_num, set_checkbox) {
	var checkbox = document.getElementById('wpkg-chk-' + elem_num);
	var item = document.getElementById('wpkg-item-' + elem_num);
	if (!checkbox || !item)
		return;
	if (set_checkbox)
		checkbox.checked = !checkbox.checked;
	var pkg_name = wrong_pkgs[elem_num];
	if (checkbox.checked) {
		parent.bottom_frame.pkgs_list[pkg_name] = true;
		++parent.bottom_frame.num_pkgs_list;
		item.className = 'selected';
	}
	else {
		parent.bottom_frame.pkgs_list[pkg_name] = false;
		--parent.bottom_frame.num_pkgs_list;
		item.className = '';
	}
	parent.bottom_frame.update_num_elems();
}

////////////////////////////////////////////////////////////////////////////////
// Work with tabs
////////////////////////////////////////////////////////////////////////////////

// Currently shown tab.
var current_tab_id = 'cur-dir';

// Switches to another tab, performing nesessary actions.
function show_tab(id) {
	if (id == current_tab_id)
		return;
	var old_elem = document.getElementById(current_tab_id);
	var old_elem_tab = document.getElementById(current_tab_id + '-tab');
	var new_elem = document.getElementById(id);
	var new_elem_tab = document.getElementById(id + '-tab');
	if (!old_elem || !old_elem_tab || !new_elem || !new_elem_tab)
		return;
	if (id == 'cur-dir') {
		var elems = new_elem.getElementsByTagName('INPUT');
		for (var i=0; i<elems.length; ++i) {
			if (elems[i].id == 'show_hidden')
				continue;
			if (elems[i].checked) {
				elems[i].checked = false;
				document.getElementById(elems[i].id.replace(/chk-/, 'item-')).className = '';
			}
		}
		check_path_items_performed = false;
		check_path_items();
	}
	else if (id == 'packages') {
		if (parent.bottom_frame.host_packages_empty) {
			ajax_call_get('action=read_packages');
			new_elem.innerHTML = '<font color="green">The list is being retrieved. Please, wait&hellip;</font>';
		}
		else {
			build_packages_table();
			check_pkg_items();
		}
	}
	else if (id == 'all-items') {
		var str = '';
		var i = 0;
		for (var path in parent.bottom_frame.paths_list) {
			if (parent.bottom_frame.paths_list[path]) {
				str += '  <tr class="clickable" onclick="javascript:selectAPathItem(' + i + ', \\'' + path + '\\', true);">\\n    <td style="width: 1.4em;"><input type="checkbox" name="apath-chk-' + i + '" id="apath-chk-' + i + '" checked="checked" onclick="javascript:selectAPathItem(' + i + ', \\'' + path + '\\', false);event.cancelBubble=true;" /></td>\\n    <td id="apath-item-' + i + '" style="width: 20em;"><b>' + path.replace(/&/g, '&amp;') + '</b></td>\\n  </tr>\\n';
				++i;
			}
		}
		i = 0;
		for (var pkg in parent.bottom_frame.pkgs_list) {
			if (parent.bottom_frame.pkgs_list[pkg]) {
				str += '  <tr class="clickable" onclick="javascript:selectAPkgItem(' + i + ', \\'' + pkg + '\\', true);">\\n    <td style="width: 1.4em;"><input type="checkbox" name="apkg-chk-' + i + '" id="apkg-chk-' + i + '" checked="checked" onclick="javascript:selectAPkgItem(' + i + ', \\'' + pkg + '\\', false);event.cancelBubble=true;" /></td>\\n    <td id="apkg-item-' + i + '" style="width: 20em;"><b>pkg:' + pkg.replace(/&/g, '&amp;') + '</b></td>\\n  </tr>\\n';
				++i;
			}
		}
		if (str != '')
			str = 'List of all currently selected entries:\\n<table class="main" style="margin-top: 10px;">\\n' + str + '</table>';
		else
			str = '<i>There are no selected files and directories.</i>';
		new_elem.innerHTML = str;
	}
	else
		return;
	old_elem_tab.className = 'tab-inactive';
	new_elem_tab.className = 'tab-active';
	old_elem.style.display = 'none';
	new_elem.style.display = '';
	current_tab_id = id;
	if (id == 'packages') {
		// Set focus into the filter editbox
		var elem = document.getElementById('filter');
		if (elem) {
			elem.focus();
		}
	}
}

// Updates internal information when (un)selecting missing files and dirs.
function selectAPathItem(elem_num, full_path, set_checkbox) {
	var checkbox = document.getElementById('apath-chk-' + elem_num);
	if (!checkbox)
		return;
	if (set_checkbox)
		checkbox.checked = !checkbox.checked;
	if (checkbox.checked) {
		parent.bottom_frame.paths_list[full_path] = true;
		++parent.bottom_frame.num_paths_list;
	}
	else {
		parent.bottom_frame.paths_list[full_path] = false;
		--parent.bottom_frame.num_paths_list;
	}
	parent.bottom_frame.update_num_elems();
}

// Updates internal information when (un)selecting missing packages.
function selectAPkgItem(elem_num, pkg, set_checkbox) {
	var checkbox = document.getElementById('apkg-chk-' + elem_num);
	if (!checkbox)
		return;
	if (set_checkbox)
		checkbox.checked = !checkbox.checked;
	if (checkbox.checked) {
		parent.bottom_frame.pkgs_list[pkg] = true;
		++parent.bottom_frame.num_pkgs_list;
	}
	else {
		parent.bottom_frame.pkgs_list[pkg] = false;
		--parent.bottom_frame.num_pkgs_list;
	}
	parent.bottom_frame.update_num_elems();
}

// Timer event to call updating packages list (it is quite a long operation and
// cannot be performed immediately)
var filter_timer = null;

// Previous filter value
var last_filter = '';

// Sets the timer for updating list of packages according to the filter
function setFilterTimeout() {
	if (filter_timer)
		clearTimeout(filter_timer);
	filter_timer = setTimeout("updatePackagesFilter();", 300);
}

// Updates the list of visible packages according to the filter
function updatePackagesFilter() {
	var filter = document.getElementById('filter');
	if (!filter || (filter.value == last_filter))
		return;
	last_filter = filter.value.toLowerCase();
	var div = document.getElementById('packages-list');
	var lines = div.getElementsByTagName('tr');
	var line_color = 0;
	last_filter = last_filter.toLowerCase();
	for (var i=0; i<lines.length; ++i) {
		var inputs = lines[i].getElementsByTagName('input');
		if (inputs.length == 0)
			continue;
		var pkg_name = inputs[0].name.substr(8);        // Remove 'pkg-chk-' prefix
		if (pkg_name.toLowerCase().indexOf(last_filter) == -1) {
			lines[i].style.display = 'none';
		}
		else {
			lines[i].style.display = '';
			lines[i].className = 'list_item' + line_color + ' clickable';
			line_color = 1 - line_color;
		}
	}
}

// Constructs the HTML table with list of packages (if necessary) and inserts it
// into the appropriate DIV element.
function build_packages_table() {
	var packages_div = document.getElementById('packages');
	if (parent.bottom_frame.host_packages_empty)
		return;
	var line_color = 0;
	last_filter = '';
	var str = '<div id="wrong_pkgs" style="display: none;">\\n<font color="red"><b>WARNING:</b></font> The following packages are selected but do not exist:<br />\\n<div id="wrong_pkgs_data">\\n</div>\\n<br />\\n</div>\\n<table style="border: solid 1px gray; background: #e0e0e0; padding: 2px;"><tr><td>Filter:&nbsp;<input type="text" id="filter" value="" onkeypress="javascript: setFilterTimeout();" /></td><td width="10"></td></tr></table><br />\\n';
DATA
		if ($is_packager_rpm) {
			print <<DATA;
	str += '<table class="main" id="packages-list">\\n  <tr>\\n    <th style="width: 1.2em;"></th>\\n    <th style="width: 20em;">Name</th>\\n    <th>Version</th>\\n    <th>Release</th>\\n  </tr>\\n';
	for (var i=0; i<parent.bottom_frame.host_packages.length; ++i) {
		var pkg = parent.bottom_frame.host_packages[i];
		str += '  <tr class="list_item' + line_color + ' clickable" onclick="javascript:selectPkgItem(\\'' + pkg['pkgid'] + '\\', \\'' + pkg['ufname'] + '\\', true);">\\n    <td align="center"><input type="checkbox" id="pkg-chk-' + pkg['pkgid'] + '" name="pkg-chk-' + pkg['nameid'] + '" onclick="javascript:selectPkgItem(\\'' + pkg['pkgid'] + '\\', \\'' + pkg['ufname'] + '\\', false);event.cancelBubble = true;" /></td>\\n    <td id="pkg-item-' + pkg['pkgid'] + '"><b>' + pkg['namedisp'] + '</b></td>\\n    <td>' + pkg['verdisp'] + '</td>\\n    <td>' + pkg['reldisp'] + '</td>\\n  </tr>\\n';
		line_color = 1 - line_color;
	}
	str += '</table>\\n';
DATA
		}
		else {
			print <<DATA;
	str += '<table class="main" id="packages-list">\\n  <tr>\\n    <th style="width: 1.2em;"></th>\\n    <th style="width: 20em;">Name</th>\\n    <th>Version</th>\\n  </tr>\\n';
	for (var i=0; i<parent.bottom_frame.host_packages.length; ++i) {
		var pkg = parent.bottom_frame.host_packages[i];
		str += '  <tr class="list_item' + line_color + ' clickable" onclick="javascript:selectPkgItem(\\'' + pkg['pkgid'] + '\\', \\'' + pkg['ufname'] + '\\', true);">\\n    <td align="center"><input type="checkbox" id="pkg-chk-' + pkg['pkgid'] + '" name="pkg-chk-' + pkg['nameid'] + '" onclick="javascript:selectPkgItem(\\'' + pkg['pkgid'] + '\\', \\'' + pkg['ufname'] + '\\', false);event.cancelBubble = true;" /></td>\\n    <td id="pkg-item-' + pkg['pkgid'] + '"><b>' + pkg['namedisp'] + '</b></td>\\n    <td>' + pkg['verdisp'] + '</td>\\n  </tr>\\n';
		line_color = 1 - line_color;
	}
	str += '</table>\\n';
DATA
		}
		print <<DATA;
	packages_div.innerHTML = str;
}

// AJAX
function ajaxProcessResult(responseXML) {
	var pkgs = responseXML.getElementsByTagName('pkg');
	if (pkgs.length > 0) {
		parent.bottom_frame.host_packages_empty = false;
		for (var i=0; i<pkgs.length; ++i) {
			var tmp = new Array();
			tmp['pkgid'] = pkgs[i].getElementsByTagName('pkgid')[0].childNodes[0].nodeValue;
			tmp['nameid'] = pkgs[i].getElementsByTagName('nameid')[0].childNodes[0].nodeValue;
			tmp['ufname'] = pkgs[i].getElementsByTagName('ufname')[0].childNodes[0].nodeValue;
			tmp['namedisp'] = pkgs[i].getElementsByTagName('namedisp')[0].childNodes[0].nodeValue;
			tmp['verdisp'] = pkgs[i].getElementsByTagName('verdisp')[0].childNodes[0].nodeValue;
DATA
		if ($is_packager_rpm) {
			print "\t\t\ttmp['reldisp'] = pkgs[i].getElementsByTagName('reldisp')[0].childNodes[0].nodeValue;\n";
		}
		print <<DATA;
			parent.bottom_frame.host_packages[i] = tmp;
		}
		build_packages_table();
		check_pkg_items();
		// Set focus into the filter editbox
		var elem = document.getElementById('filter');
		if (elem) {
			elem.focus();
		}
	}
}
// ]]>
</script>
DATA
	}

	print <<DATA;
</body>
</html>
DATA
}
else {
	print <<DATA;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <title>Error</title>
</head>

<body>
<h2 style="color: red;">Wrong "_frame" argument!</h2>
</body>
</html>
DATA
}
